# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS & White Box as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "wbel"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Name:		perl-File-Slurp
Version:	9999.19
Release:	1.%{__distinit}%{__distvers}
Summary:	Efficient Reading/Writing of Complete Files
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/File-Slurp/
Source0:	http://search.cpan.org/CPAN/authors/id/U/UR/URI/File-Slurp-%{version}.tar.gz
Patch0:		File-Slurp-9999.14-UTF-8.patch
Patch1:		File-Slurp-9999.18-Perl580.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
BuildRequires:	perl(Test::Pod) >= 1.14
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Filter unwanted perl provides and requires (rpm 4.9 onwards)
%global __provides_exclude ^perl\\(FileSlurp_12\\)
%global __requires_exclude ^perl\\((base|Symbol)\\)

%description
This module provides subs that allow you to read or write entire files with
one simple call. They are designed to be simple to use, have flexible ways
to pass in or get the file contents and to be very efficient. There is also
a sub to read in all the files in a directory other than . and ..

These slurp/spew subs work for files, pipes and sockets, and stdio, 
pseudo-files, and DATA.

%prep
%setup -q -n File-Slurp-%{version}

# Recode Changes file as UTF-8
%patch0 -p1

# Perl 5.8.0 has problems in t/pseudo.t with the binary data in /proc/$$/auxv
# so we use the plain text file /proc/$$/mounts instead
#
# Also silence the warning about non-portable v-strings
%if %(perl -e 'print (($] < 5.008001) ? 1 : 0);')
%patch1 -p1
%endif

# Fix permissions and shellbang for benchmarking script
chmod 644 lib/File/Slurp.pm extras/slurp_bench.pl
perl -pi -e 's|^#!/usr/local/bin/perl\b|#!/usr/bin/perl|' extras/slurp_bench.pl

# Filter unwanted perl provides and requires (prior to rpm 4.9)
%global perl_provfilt /bin/sh -c "%{__perl_provides} | sed -e '/^perl(FileSlurp_12)/d'"
%define __perl_provides %{perl_provfilt}
%global perl_reqfilt /bin/sh -c "%{__perl_requires} | sed -e '/^perl(base)/d' -e '/^perl(Symbol)/d'"
%define __perl_requires %{perl_reqfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
%{_fixperms} %{buildroot}

%clean
rm -rf %{buildroot}

%check
make test

%files
%defattr(-,root,root,-)
%doc Changes README TODO extras/
%{perl_vendorlib}/File/
%{_mandir}/man3/File::Slurp.3pm*

%changelog
* Tue Jun  7 2011 Paul Howarth <paul@city-fan.org> - 9999.19-1
- Update to 9999.19:
  - Fixed use line in t/edit_file.t to import :edit first (CPAN RT#68229)
  - read_file and write_file work even when interrupted by signals
  - Fixed bugs in the config synopsis example
- Drop upstreamed patch for CPAN RT#68229

* Fri May 13 2011 Paul Howarth <paul@city-fan.org> - 9999.18-1
- Update to 9999.18:
  - Added :std and :edit export tags
  - Cleaned up EXPORT vars
  - Documented importing edit_file and edit_file_lines
  - Fixed some pod spelling
- Add patch to work around test incompatibility with Exporter < 5.58
  (CPAN RT#68229)

* Fri May 13 2011 Paul Howarth <paul@city-fan.org> - 9999.17-1
- Update to 9999.17:
  - Requiring Perl 5.6.2 (first time older Perls were dropped); this is because
    of use of the "re 'taint'" pragma
  - Added major new features: edit_file and edit_file_lines
  - Speed up of tainted slurp with return of lines
  - Added chomp option to read_file
  - Added prefix option to read_dir
  - Fixed optimization of reading small files
- Filter doc-file dependency perl(Symbol)

* Sun Apr 24 2011 Paul Howarth <paul@city-fan.org> - 9999.16-1
- Update to 9999.16:
  - Added support for read_file options to be a hash reference
  - Added support for read_dir options to be a hash reference
  - Added new feature prepend_file
  - Fixed bug with array_ref in list context, introduced by .15/.14
  - Cleaned up some pod

* Fri Mar 25 2011 Paul Howarth <paul@city-fan.org> - 9999.15-1
- Update to 9999.15:
  - Fixed error.t test so it works when run as root
  - Removed skip lines from error.t
  - Fixed POD about binmode option to reflect changes in 9999.14

* Wed Mar 23 2011 Paul Howarth <paul@city-fan.org> - 9999.14-1
- Update to 9999.14:
  - Added LICENCE (same as perl) to POD
  - Added special faster code to slurp in small text files (a common case)
  - Rewrote the extras/slurp_bench.pl script, which now has a full legend,
    better CLI options, size is selectable, benchmark entries have more
    consistent names and it compares the new fast slurp for small files to the
    general slurp code
  - Cleaned up POD
  - Added more Synopsis examples
  - Added t/error.t to actually test error conditions; previous error.t was
    renamed to error_mode.t which better reflects its tests
  - t/error.t uses a new test driver module, which may get used by other tests
    in the future
  - Fixed check for SEEK_SET and other constant subs being defined
  - Added support for binmode other than :raw and binmode.t test
  - Added support for perms option in write_file and perms.t test
  - Added check to the rename call in atomic mode, tested in error.t.
  - Added POD to state that using scalar_ref or buf_ref will be faster and save
    memory due to not making a copy
  - read_file in list mode keeps data tainted
  - read_file checks for an overloaded object to get the file name
- Nobody else likes macros for commands
- Package TODO and experiment/ directory
- Filter bogus provides from extras/ directory
- Filter doc-file-dependency perl(base) from requires
- Recode Changes file as UTF-8
- Patch t/pseudo.t so that it can work with Perl 5.8.0

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 9999.13-9
- Import from Fedora

* Sat May  1 2010 Marcela Maslanova <mmaslano@redhat.com> - 9999.13-8
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 9999.13-7
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 9999.13-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 9999.13-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Jul  9 2008 Ralf Corsépius <rc040203@freenet.de> - 9999.13-4
- Re-activate tests

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 9999.13-3
- Rebuild for perl 5.10 (again)

* Thu Jan 24 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 9999.13-2
- Disable tests, due to wacky Fedora builders

* Thu Jan 24 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 9999.13-1
- Go to 9999.13 to fix build failures against perl 5.10.0

* Sun Jan 20 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 9999.12-4
- Rebuild for new perl

* Sun Sep  2 2007 Ralf Corsépius <rc040203@freenet.de> - 9999.12-3
- Update license tag
- BR: perl(ExtUtils::MakeMaker)

* Tue Sep  5 2006 Ralf Corsépius <rc040203@freenet.de> - 9999.12-2
- Mass rebuild

* Sat Mar 18 2006 Ralf Corsépius <rc040203@freenet.de> - 9999.12-1
- Upstream update

* Wed Mar  1 2006 Ralf Corsépius <rc040203@freenet.de> - 9999.11-2
- Rebuild for perl-5.8.8

* Wed Feb  1 2006 Ralf Corsépius <rc040203@freenet.de> - 9999.11-1
- Upstream update
- BR perl(Test::Pod), perl(Test::Pod::Coverage)
